
template<typename R> inline
mmx_obj<R>
as_mmx_obj (generic g)
{
  if (gentype(g) != mmx_rep<R>::TYPE)
    fatal_error ("generic is not an mmx_obj of required type",
		 "as_mmx_obj", "link.H");
  return mmx_obj<R> ((mmx_rep<R>*)g.rep); 
}

/******************************************************************************
* Required mmx_ints for generic structures
******************************************************************************/

template<typename R>
int
mmx_rep<R>::Type () {
  return TYPE;
}

//template<typename R> int mmx_rep<R>::Hash () {return 1;}

template<typename R>
bool
mmx_rep<R>::Equal (generic g) const  {
  if (gentype (g) != mmx_rep<R>::TYPE) return false;
  return mmx_obj<R> (this) == as_mmx_obj<R> (g);
}

template<typename R>
generic
mmx_rep<R>::Copy () {
  return copy (mmx_obj<R> (this));
}

template<typename R>
int
mmx_rep<R>::Arity () {
  return 0;
}

template<typename R>
void
mmx_rep<R>::Print (ostream& out) {
  out << mmx_obj<R> (this);
}

/****************************************************************************
* Routines for mmx_obj
****************************************************************************/

template<typename R>
ostream& operator << (ostream& out, mmx_obj<R> x) 
{
  return out << x->data;
}

template<typename R>
mmx_obj<R> copy (mmx_obj<R>  x)  
{
  return mmx_obj<R> (x->data);
}
