
/******************************************************************************
* MODULE     : printer.cc
* DESCRIPTION: printers
* COPYRIGHT  : (C) 2000  Joris van der Hoeven
*******************************************************************************
* This software falls under the GNU general public license and comes WITHOUT
* ANY WARRANTY WHATSOEVER. See the file $TEXMACS_PATH/LICENSE for more details.
* If you don't have this file, write to the Free Software Foundation, Inc.,
* 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
******************************************************************************/

#include <printer.hh>
#include <symbol.hh>
namespace mmx {

/******************************************************************************
* Required routines for generic structures
******************************************************************************/

int
printer_rep::Type () {
  return PRINTER_TYPE;
}

int
printer_rep::Hash () {
  return hash (name) ^ 12345;
}

bool
printer_rep::Equal (generic g) {
  if (gentype (g) != PRINTER_TYPE) return false;
  return printer (this) == as_printer (g);
}

generic
printer_rep::Copy () {
  return copy (printer (this));
}

int
printer_rep::Arity () {
  return 0;
}

void
printer_rep::Print (ostream& out) {
  out << printer (this);
}

/******************************************************************************
* Routines for printers
******************************************************************************/

generic
std_name (ostream& out) {
  if ((&out) == (&cout)) return symbol ("mmout");
  if ((&out) == (&cerr)) return symbol ("mmerr");
  return symbol ("unknown");
}

ostream&
operator << (ostream& out, printer f) {
  return out << "printer<" << f->name << ">";
}

printer
copy (printer out) {
  return printer (out->name, out->out);
}

} // namespace mmx
